package com.pseudocode.photolib.transforms;

/**
 * Specifies the shape of the resize & crop for a specific original / transform combination
 */
class ImageShape {

	private int height;
	private int width;
	private boolean crop;
	private int bottom;
	private int left;
	private int right;
	private int top;
	private int multiplier;

	/**
	 * Gets the height of the shape
	 */
	public int height() {
		return height;
	}

	/**
	 * Sets the height of the shape
	 */
	public ImageShape height(int value) {
		height = value;
		return this;
	}

	/**
	 * Gets the width of the shape
	 */
	public int width() {
		return width;
	}

	/**
	 * Sets the width of the shape
	 */
	public ImageShape width(int value) {
		width = value;
		return this;
	}

	/**
	 * Gets if crop is specified
	 */
	public boolean crop() {
		return crop;
	}
	
	/**
	 * Sets if crop is specified
	 */
	public ImageShape crop(boolean value) {
		crop = value;
		return this;
	}

	/**
	 * Gets the bottom of the shape
	 */
	public int bottom() {
		return bottom;
	}

	/**
	 * Sets the bottom of the shape
	 */
	public ImageShape bottom(int value) {
		bottom = value;
		return this;
	}

	/**
	 * Gets the left of the shape
	 */
	public int left() {
		return left;
	}

	/**
	 * Sets the left of the shape
	 */
	public ImageShape left(int value) {
		left = value;
		return this;
	}

	/**
	 * Gets the right of the shape
	 */
	public int right() {
		return right;
	}

	/**
	 * Sets the right of the shape
	 */
	public ImageShape right(int value) {
		right = value;
		return this;
	}

	/**
	 * Gets the top of the shape
	 */
	public int top() {
		return top;
	}

	/**
	 * Sets the top of the shape
	 */
	public ImageShape top(int value) {
		top = value;
		return this;
	}

	/**
	 * Gets the anti-alias multiplier to start downsize
	 */
	public int multiplier() {
		return multiplier;
	}

	/**
	 * Sets the anti-alias multiplier to start downsize
	 */
	public ImageShape multiplier(int value) {
		multiplier = value;
		return this;
	}
}
